'
'  ff_pb_ini.bas
'  Ini File Manipulation routines
'
'  Public Domain Routies from
'  Don Dickinson
'  http://www.greatwebdivide.com
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  getIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function getIni alias "getIni" _
      ( byval sFile as string, byval sSection as string, _
        byval sKey as string, byval sDefault as string ) export as string

   dim szString as asciiz * 1000
   dim szFile as asciiz * 300
   dim szSection as asciiz * 300
   dim szKey as asciiz * 300
   dim szDefault as asciiz * 300

   szFile = sFile
   szSection = sSection
   szKey = sKey
   szDefault = sDefault
   getprivateprofilestring szSection, szKey, szDefault, szString, 1000, szFile

   function = trim$(szString)

end function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  getIniBoolean
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function getIniBoolean alias "getIniBoolean" _
      ( byval sFile as string, byval sSection as string, _
        byval sKey as string, byval iDefault as long ) export as long
   
   dim sVal as string
   dim sDefault as string
   
   if iDefault then 
      sDefault = "Y"
   else
      sDefault = "N"
   end if
   
   sVal = trim$(ucase$(getIni(sFile, sSection, sKey, sDefault)))
   if iDefault then      
      select case sVal
         case "0", "N", "F"
            function = %false
         case else
            function = %true
      end select
   else
      select case sVal
         case "1", "-", "T", "Y"
            function = %true
         case else
            function = %false
      end select
   end if
   
end function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  writeIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub writeIni alias "writeIni" _
      ( byval sFile as string, byval sSection as string, _
        byval sKey as string, byval sData as string) export

   dim zFile as asciiz * 300
   dim zSection as asciiz * 300
   dim zKey as asciiz * 300
   dim zData as asciiz * 1000

   zFile = trim$(sFile)
   zSection = trim$(sSection)
   zKey = trim$(sKey)
   zData = trim$(sData)
   writeprivateprofilestring zSection, zKey, zData, zFile

end sub


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  getWinIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function getWinIni alias "GetWinIni" _
      ( byval sSection as string, byval sKey as string, _
        byval sDefault as string ) export as string

   function = GetIni("win.ini", sSection, sKey, sDefault)

end function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  writeWinIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub writeWinIni alias "WriteWinIni" _
      ( byval sSection as string, byval sKey as string, _
        byval sData as string ) export

   dim zSection as asciiz * 300
   dim zKey as asciiz * 300
   dim zData as asciiz * 1000
   zSection = trim$(sSection)
   zKey = trim$(sKey)
   zData = trim$(sData)
   writeprofilestring zSection, zKey, zData
end sub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  writeIni
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub writeIniBoolean alias "writeIniBoolean" _
      ( byval sFile as string, byval sSection as string, _
        byval sKey as string, byval bValue as long) export
   
   if bValue then
      writeIni sFile, sSection, sKey, "Y"
   else
      writeIni sFile, sSection, sKey, "N"
   end if
   
end sub
