'
'  pb_smime.bas
'
'  Encoding
'  Convert a string to MIME encoded string (Base64 Encoded) for PB/DLL or PB/CC
'  by Dave Navarro (dave@basicguru.com)
'
'  Decoding
'  Original VBDOS Version by G. Balla, 1996 (Public Domain)
'  PB/DOS Conversion by Marc van den Dikkenberg, 1999
'  PB/CC Conversion by Don Dickinson, 2001
'

#If Not %Def(%PB_MIME2_BAS)
%PB_MIME2_BAS = 1

$PB_MIME_ALPHABET   = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
%IC_CHOP_MASK       = 255
%IC_BIT_SHIFT       = 4
%IC_START_MASK      = &h10

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  mimeEncode
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function mimeEncode( ByVal inString As String, outString as String ) as Long
                     
   Register i        As Long
   Dim iIn           As Long
   Dim iOut          As Long
   Dim iNameField    As Long
   Dim iCount        As Long
   Dim iTotal        As Long
	Dim iProgress     As Long   
   Dim Enc           As String * 64
   Dim b             As Asciiz * 4
   Dim InBuff        As String
   Dim OutBuff       As String
   Dim InFileName    As String
   
   Enc = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
   outString = ""

   While len(inString)
      
      InBuff = left$(inString, 57)
      inString = mid$(inString, 58)
      'Get$ iIn, 57, InBuff
      OutBuff = ""
      While Len(InBuff)
         b = Left$(InBuff, 3)
         ! mov AL, b[0]
         ! shr AL, 2
         ! movzx i, AL
         OutBuff = OutBuff + Mid$(Enc, i+1, 1)
         ! mov AL, b[1]
         ! mov AH, b[0]
         ! shr AX, 4
         ! and AL, &H3F
         ! movzx i, AL
         OutBuff = OutBuff + Mid$(Enc, i+1, 1)
         If Len(InBuff) = 1 Then
            OutBuff = OutBuff + "=="
            Exit Do
         End If
         ! mov AL, b[2]
         ! mov AH, b[1]
         ! shr AX, 6
         ! and AL, &H3F
         ! movzx i, AL
         OutBuff = OutBuff + Mid$(Enc, i+1, 1)
         If Len(InBuff) = 2 Then
            OutBuff = OutBuff + "="
            Exit Do
         End If
         ! mov AL, b[2]
         ! and AL, &H3F
         ! movzx i, AL
         OutBuff = OutBuff + Mid$(Enc, i+1, 1)
         InBuff = Mid$(InBuff, 4)
         If Err Then Exit Do
      Wend
      if outString = "" then
         outString = OutBuff
      else
         outString = outString + $CRLF + OutBuff
      end if
   Wend

   Function = %True
exit function

mimeEncode_Error:
   Function = %False

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  mimeDecode
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function mimeDecode Alias "mimeDecode" _
      (  ByVal sEncoded as String, outString as String, _
         iEndOfText as Long) Export as Long

   Dim iCounter as Long
   Dim iPtr as Integer
   Dim iChar as Integer
   Dim iShift as Integer
   Dim iLowShift as Integer
   Dim iRollover as Integer   
   Dim iHighMask as Integer
   Dim sTemp as String
   
   iShift = %IC_BIT_SHIFT
   iLowShift = 0
   iRollover = 0
   iHighMask = -1
   
   if len(sEncoded) < 1 then
      Function = %False
      exit function
   end if
   
   For iCounter = 1 to len(sEncoded)

        iChar = asc(mid$(sEncoded, iCounter, 1))

        iPtr = instr($PB_MIME_ALPHABET, chr$(iChar)) - 1
        if iPtr >= 0 then
            if iShift = %IC_BIT_SHIFT then

                iRollOver = (iPtr * iShift) and %IC_CHOP_MASK
                iHighMask = &H30
                iLowShift = %IC_START_MASK
                iShift = %IC_START_MASK

            else
                sTemp = sTemp + chr$(iRollOver or ((iPtr and iHighMask) / iLowShift))
                iRollOver = (iPtr * iShift) and %IC_CHOP_MASK
                iShift = iShift * %IC_BIT_SHIFT
                iHighMask = (iHighMask \ %IC_BIT_SHIFT) or &H30
                iLowShift = iLowShift / %IC_BIT_SHIFT
                if iShift > 256 then
                    iShift = %IC_BIT_SHIFT
                    iLowShift = 0
                end if
            end if
        end if
    next iCounter

    if (iShift > %IC_BIT_SHIFT and iShift < 256) then
        if iEndOfText then
            sTemp = sTemp + chr$(iRollOver)
        end if
    end if

    outString = sTemp
    Function = %True
    
End Function

#EndIf



      
